from __future__ import division

import vector

class cdict(object):
    def __init__(self, getter):
        self.getter = getter
        self._dict = {}
    def __getitem__(self, item):
        try:
            return self._dict[item]
        except KeyError:
            self._dict[item] = result = self.getter(item)
            return result

def closest_point_on_line((line_a, line_b), point): 
    ap = point - line_a
    ab = line_b - line_a
    ab2 = (ab*ab).sum()
    ap_ab = (ap*ab).sum()
    t = ap_ab / ab2
    t = max(0, t) # clamp to > 0
    t = min(1, t) # clamp to < 1
    return line_a + ab * t

def line_intersection(((x1, y1), (x2, y2)), ((x3, y3), (x4, y4))):
    b = (y4-y3)*(x2-x1)-(x4-x3)*(y2-y1)
    if b == 0: return None
    b = ((x4-x3)*(y1-y3)-(y4-y3)*(x1-x3))/b
    if .01 <= b <= 1-.01:
        return vector.v(x1+(x2-x1)*b, y1+(y2-y1)*b)
